/*
** Copyright (C) 2003-2005 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#include "utilities.h"
#include "scripting.h"


Scripting::Scripting (int dummy)
{
  ustring filename = temporary_file ("scripting");
  unlink (filename.c_str());
  mkfifo (filename.c_str(), 0666);
  GError * error = NULL;
  giochannel = NULL;
  giochannel = g_io_channel_new_file (filename.c_str(), "r+", &error);
  if (error) {
    cerr << error->message << endl;
    g_error_free (error);
  }
}


Scripting::~Scripting ()
{
  if (giochannel) {
    g_io_channel_close (giochannel);
  }
}


/*
Todo scripting solution for Bibledit

We need scripting support. Just make own scripting language. For testing purposes, automatic conversion.
Bibledit opens a pipe and connects a signal handler.
A script can send characters to the pipe.
When a character comes in on the pipe, a signal will be given. Filter out things, and if we've a full command, then call a routine.
Needs routines for creating the pipe, closing the pipe, handling data.
Example commands in dialog: 
ok – clicks ok
entry /home/teus/XEP – sets text in entry

Dialog created: Create Scripting module, set pipe, connect signal.
Dialog destroyed Destroy Scripting module.

*/
